package com.vcarecity.test;

import com.google.inject.Guice;
import com.google.inject.Injector;
import com.vcarecity.test.module.DbModule;
import com.vcarecity.test.module.PropertiesModule;
import com.vcarecity.test.module.ServiceModule;
import com.vcarecity.test.properties.ConfigProperties;
import com.vcarecity.test.task.ImportTask;
import me.yuxiaoyao.config.loader.ConfigLoader;

/**
 * @author Kerry on 19/12/09
 */

public class HighClientApp {

    public static Injector injector;

    public static void main(String[] args) {
        run(args);
        final ImportTask instance = injector.getInstance(ImportTask.class);
        instance.startTask();

        instance.stopApp();
    }

    public static void run(String[] args) {
        final ConfigProperties configProperties = loadProperties(args);
        injector = createInjector(configProperties);
    }

    public static ConfigProperties loadProperties(String[] args) {
        return ConfigLoader.parseConfig(args, ConfigProperties.class, null);
    }

    public static Injector createInjector() {
        return createInjector(null);
    }

    public static Injector createInjector(ConfigProperties configProperties) {
        return Guice.createInjector(
                new PropertiesModule(configProperties),
                new DbModule(),
                new ServiceModule()
        );
    }


}
