package com.vcarecity.test.core;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Kerry on 19/12/09
 */

public class ResultMapper {
    public static ObjectResultWrapper<Object[]> getResultSet(ResultSet rs) throws SQLException {
        final ResultSetMetaData metaData = rs.getMetaData();
        final int columnCount = metaData.getColumnCount();
        String[] headers = new String[columnCount];
        for (int i = 0; i < columnCount; i++) {
            headers[i] = metaData.getColumnName(i + 1);
        }
        ObjectResultWrapper<Object[]> resultWrapper = new ObjectResultWrapper<>();
        resultWrapper.setHeaders(headers);

        List<Object[]> result = new ArrayList<>();
        int index = 0;
        while (rs.next()) {
            Object[] columns = new Object[columnCount];
            for (int i = 0; i < columnCount; i++) {
                columns[i] = rs.getObject(i + 1);
            }
            result.add(columns);
        }
        resultWrapper.setDataList(result);
        return resultWrapper;
    }

}
