package com.vcarecity.test.typehandler;

import com.google.inject.ImplementedBy;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * @author Kerry on 19/12/10
 */

@ImplementedBy(AutoTypeHandler.class)
public interface TypeHandler {

    Map<Class<?>, List<TypeParam>> TYPE_CACHE = new ConcurrentHashMap<>();

    /**
     * 处理
     *
     * @param resultSet
     * @param cls
     * @return
     * @throws SQLException
     * @throws IllegalAccessException
     * @throws InstantiationException
     */
    <T> List<T> resultHandler(ResultSet resultSet, Class<T> cls) throws SQLException, IllegalAccessException, InstantiationException;


}
