package com.vcarecity.elastic.publish.controller;

import com.vcarecity.elastic.publish.pojo.dto.UnitAgencyDTO;
import com.vcarecity.elastic.publish.pojo.query.UnitAgencyQuery;
import com.vcarecity.elastic.publish.service.UnitService;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;
import java.io.IOException;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author Kerry on 19/12/11
 */

@RestController
public class MainController {

    private final UnitService unitService;

    public MainController(UnitService unitService) {
        this.unitService = unitService;
    }

    @PostMapping("/query-unit-agency")
    public Object queryUnitAgency(@RequestBody @Valid UnitAgencyQuery unitAgencyQuery) throws IOException {
        final List<UnitAgencyDTO> unitAgencyByQuery = unitService.getUnitAgencyByQuery(unitAgencyQuery.getAgencyPath(), unitAgencyQuery.getKeyword(),
                unitAgencyQuery.getPage(), unitAgencyQuery.getSize(), "unit-agency");
        return unitAgencyByQuery.stream().map(UnitAgencyDTO::getUnitId).collect(Collectors.toList());
    }

    @PostMapping("/test/query-unit-agency")
    public Object testQueryUnitAgency(@RequestBody @Valid UnitAgencyQuery unitAgencyQuery) throws IOException {
        return unitService.getUnitAgencyByQuery(unitAgencyQuery.getAgencyPath(), unitAgencyQuery.getKeyword(),
                unitAgencyQuery.getPage(), unitAgencyQuery.getSize(), "unit-agency");
    }


}
