package com.vcarecity.elastic.publish.service.impl;

import com.vcarecity.elastic.publish.service.CheckTimeService;
import com.vcarecity.elastic.publish.util.DateUtil;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.time.ZoneId;
import java.util.Date;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * @author VcKerry on 12/17/19
 */

@Service
public class CheckTimeServiceImpl implements CheckTimeService {

    private final Map<String, Long> timeCache = new ConcurrentHashMap<>(4);


    @Override
    public String getLastDateTime(String key) {

        Long aLong = timeCache.get(key);
        if (aLong == null) {
            aLong = System.currentTimeMillis();
            timeCache.put(key, aLong);
        }
        return LocalDateTime.ofInstant(new Date(aLong).toInstant(), ZoneId.systemDefault()).format(DateUtil.DATE_TIME_FORMATTER);
    }

    @Override
    public void setLastDateTime(String key, long lastDateTime) {
        timeCache.put(key, lastDateTime);
    }
}
