package com.vcarecity.elastic.publish.task;

import com.vcarecity.elastic.publish.entity.UnitAgencyMergeEntity;
import com.vcarecity.elastic.publish.mapper.AgencyMapper;
import com.vcarecity.elastic.publish.mapper.BuildingMapper;
import com.vcarecity.elastic.publish.mapper.UnitMapper;
import com.vcarecity.elastic.publish.service.CheckTimeService;
import com.vcarecity.elastic.publish.util.DateUtil;

import java.time.LocalDateTime;
import java.time.ZoneId;
import java.util.Date;
import java.util.List;

/**
 * @author Kerry on 19/12/11
 */

//@Component
public class CheckUpdateTask {

    private final CheckTimeService checkTimeService;
    private final AgencyMapper agencyMapper;
    private final UnitMapper unitMapper;
    private final BuildingMapper buildingMapper;

    public CheckUpdateTask(CheckTimeService checkTimeService, AgencyMapper agencyMapper,
                           UnitMapper unitMapper,
                           BuildingMapper buildingMapper) {
        this.checkTimeService = checkTimeService;
        this.agencyMapper = agencyMapper;
        this.unitMapper = unitMapper;
        this.buildingMapper = buildingMapper;
    }


    public void checkTask() {

        long curCheckTime = System.currentTimeMillis();
        String toDateTime = LocalDateTime.ofInstant(new Date(curCheckTime).toInstant(), ZoneId.systemDefault()).format(DateUtil.DATE_TIME_FORMATTER);

        List<UnitAgencyMergeEntity> updateUaList;
        String fromDateTime;

        fromDateTime = checkTimeService.getLastDateTime("T_UNIT");
        updateUaList = unitMapper.findUpdateUaList(fromDateTime, toDateTime);
        if (!updateUaList.isEmpty()) {

        }
        checkTimeService.setLastDateTime("T_UNIT", curCheckTime);
        updateUaList.clear();

        fromDateTime = checkTimeService.getLastDateTime("T_AGENCY");
        updateUaList = agencyMapper.findUpdateUaList(fromDateTime, toDateTime);

        if (!updateUaList.isEmpty()) {

        }
        checkTimeService.setLastDateTime("T_AGENCY", curCheckTime);
        updateUaList.clear();


    }

}
